Index: TvEngine3/TVLibrary/SetupTv/Sections/RadioChannelMapping.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/RadioChannelMapping.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/RadioChannelMapping.cs	(working copy)
@@ -22,11 +22,10 @@
 using System.Collections.Generic;
 using System.Windows.Forms;
 using TvControl;
-using Gentle.Framework;
 using TvDatabase;
-using MediaPortal.UserInterface.Controls;
 using TvLibrary.Interfaces;
-using TvLibrary.Log;
+using MediaPortal.UserInterface.Controls;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -68,11 +67,8 @@
       lvwColumnSorter2 = new MPListViewStringColumnSorter();
       lvwColumnSorter2.Order = SortOrder.Ascending;
       mpListViewMapped.ListViewItemSorter = lvwColumnSorter2;
-      //mpListViewChannels.ListViewItemSorter = new MPListViewSortOnColumn(0);
-      //mpListViewMapped.ListViewItemSorter = new MPListViewSortOnColumn(0);
     }
 
-
     public override void OnSectionActivated()
     {
       mpComboBoxCard.Items.Clear();
@@ -89,8 +85,7 @@
         mpComboBoxCard.SelectedIndex = 0;
     }
 
-
-    private void mpButtonMap_Click_1(object sender, EventArgs e)
+    private void mpButtonMap_Click(object sender, EventArgs e)
     {
       NotifyForm dlg = new NotifyForm("Mapping selected channels to TV-Card...",
                                       "This can take some time\n\nPlease be patient...");
@@ -106,11 +101,15 @@
         foreach (ListViewItem item in selectedItems)
         {
           Channel channel = (Channel)item.Tag;
-          ChannelMap map = layer.MapChannelToCard(card, channel, false);
+          ChannelMap map = layer.MapChannelToCard(card, channel, mpCheckBoxMapForEpgOnly.Checked);
           mpListViewChannels.Items.Remove(item);
-          ListViewItem newItem = mpListViewMapped.Items.Add(channel.DisplayName, item.ImageIndex);
+          string displayName = channel.DisplayName;
+          if (mpCheckBoxMapForEpgOnly.Checked)
+            displayName += " (EPG Only)";
+          ListViewItem newItem = mpListViewMapped.Items.Add(displayName, item.ImageIndex);
           newItem.Tag = map;
         }
+        mpListViewMapped.Sort();
         dlg.Close();
       }
       finally
@@ -120,8 +119,7 @@
       }
     }
 
-
-    private void mpButtonUnmap_Click_1(object sender, EventArgs e)
+    private void mpButtonUnmap_Click(object sender, EventArgs e)
     {
       NotifyForm dlg = new NotifyForm("Unmapping selected channels from TV-Card...",
                                       "This can take some time\n\nPlease be patient...");
@@ -129,6 +127,7 @@
       dlg.WaitForDisplay();
       mpListViewChannels.BeginUpdate();
       mpListViewMapped.BeginUpdate();
+
       try
       {
         ListView.SelectedListViewItemCollection selectedItems = mpListViewMapped.SelectedItems;
@@ -153,52 +152,44 @@
       }
     }
 
-
-    private void mpComboBoxCard_SelectedIndexChanged_1(object sender, EventArgs e)
+    private void mpComboBoxCard_SelectedIndexChanged(object sender, EventArgs e)
     {
+      Application.UseWaitCursor = true;
       mpListViewChannels.BeginUpdate();
       mpListViewMapped.BeginUpdate();
       try
       {
-        mpListViewMapped.Items.Clear();
         mpListViewChannels.Items.Clear();
+        mpListViewMapped.Items.Clear();
 
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (Channel));
-        sb.AddOrderByField(true, "sortOrder");
-        SqlStatement stmt = sb.GetStatement(true);
-        IList<Channel> channels = ObjectFactory.GetCollection<Channel>(stmt.Execute());
-
         Card card = ((CardInfo)mpComboBoxCard.SelectedItem).Card;
-        IList<ChannelMap> maps = card.ReferringChannelMap();
 
-        // get cardtype, dvb, analogue etc.		
+        IList<Channel> channels = ChannelListHelper.GetChannelsOfTypeForGroup(-1, ChannelType.Radio);
+
+        // get cardtype - dvb, analogue etc.
         CardType cardType = RemoteControl.Instance.Type(card.IdCard);
+
         TvBusinessLayer layer = new TvBusinessLayer();
         bool enableDVBS2 = (layer.GetSetting("dvbs" + card.IdCard + "enabledvbs2", "false").Value == "true");
 
         List<ListViewItem> items = new List<ListViewItem>();
+
+        IDictionary<int, Channel> dChannels = ChannelListHelper.GetDictionaryOfChannelsForGroup(-1, ChannelType.Radio);
+        IDictionary<int, IList<TuningDetail>> dDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, ChannelType.Radio);
+        IList<ChannelMap> maps = card.ReferringChannelMap();
         foreach (ChannelMap map in maps)
         {
           Channel channel = null;
-          try
-          {
-            channel = map.ReferencedChannel();
-          }
-          catch (Exception) {}
-          if (channel == null)
+          if (!dChannels.TryGetValue(map.IdChannel, out channel))
             continue;
-          if (channel.IsRadio == false)
-            continue;
 
-
-          List<TuningDetail> tuningDetails = GetTuningDetailsByCardType(channel, cardType, enableDVBS2);
-          bool foundValidTuningDetail = tuningDetails.Count > 0;
-          if (foundValidTuningDetail)
+          List<TuningDetail> tuningDetails = ChannelListHelper.GetTuningDetailsByCardType(channel, dDetails, cardType, enableDVBS2);
+          if (tuningDetails.Count > 0)
           {
-            int imageIndex = GetImageIndex(tuningDetails);
             string displayName = channel.DisplayName;
             if (map.EpgOnly)
-              displayName = channel.DisplayName + " (EPG Only)";
+              displayName += " (EPG Only)";
+            int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
             ListViewItem item = new ListViewItem(displayName, imageIndex);
             item.Tag = map;
             items.Add(item);
@@ -214,23 +205,18 @@
             }
           }
           else
-          {
             map.Delete();
-          }
         }
         mpListViewMapped.Items.AddRange(items.ToArray());
 
         items = new List<ListViewItem>();
         foreach (Channel channel in channels)
         {
-          if (!channel.IsRadio)
-            continue;
-          List<TuningDetail> tuningDetails = GetTuningDetailsByCardType(channel, cardType, enableDVBS2);
+          List<TuningDetail> tuningDetails = ChannelListHelper.GetTuningDetailsByCardType(channel, dDetails, cardType, enableDVBS2);
           // only add channel that is tuneable on the device selected.
-          bool foundValidTuningDetail = tuningDetails.Count > 0;
-          if (foundValidTuningDetail)
+          if (tuningDetails.Count > 0)
           {
-            int imageIndex = GetImageIndex(tuningDetails);
+            int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
             ListViewItem item = new ListViewItem(channel.DisplayName, imageIndex);
             item.Tag = channel;
             items.Add(item);
@@ -243,6 +229,7 @@
       {
         mpListViewChannels.EndUpdate();
         mpListViewMapped.EndUpdate();
+        Application.UseWaitCursor = false;
       }
     }
 
@@ -305,90 +292,5 @@
       }
       map.Persist();
     }
-
-    private static List<TuningDetail> GetTuningDetailsByCardType(Channel channel, CardType cardType, bool enableDVBS2)
-    {
-      List<TuningDetail> result = new List<TuningDetail>();
-      foreach (TuningDetail tDetail in channel.ReferringTuningDetail())
-      {
-        switch (cardType)
-        {
-          case CardType.Analog:
-            if (tDetail.ChannelType == 0)
-              result.Add(tDetail);
-            break;
-          case CardType.Atsc:
-            if (tDetail.ChannelType == 1)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbC:
-            if (tDetail.ChannelType == 2)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbS:
-            if (tDetail.ChannelType == 3)
-            {
-              if (!enableDVBS2 && (tDetail.Pilot > -1 || tDetail.RollOff > -1))
-              {
-                Log.Debug(String.Format(
-                  "Imported channel {0} detected as DVB-S2. Skipped! \n Enable \"DVB-S2 tuning\" option in your TV-Card properties to be able to map these channels.",
-                  tDetail.Name));
-              }
-              else
-              {
-                result.Add(tDetail);
-              }
-            }
-            break;
-          case CardType.DvbT:
-            if (tDetail.ChannelType == 4)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbIP:
-            if (tDetail.ChannelType == 7)
-              result.Add(tDetail);
-            break;
-          case CardType.RadioWebStream:
-            if (tDetail.ChannelType == 5)
-              result.Add(tDetail);
-            break;
-          default:
-            break;
-        }
-      }
-      return result;
-    }
-
-    private static int GetImageIndex(IList<TuningDetail> tuningDetails)
-    {
-      bool hasFta = false;
-      bool hasScrambled = false;
-      foreach (TuningDetail detail in tuningDetails)
-      {
-        if (detail.FreeToAir)
-        {
-          hasFta = true;
-        }
-        if (!detail.FreeToAir)
-        {
-          hasScrambled = true;
-        }
-      }
-
-      int imageIndex;
-      if (hasFta && hasScrambled)
-      {
-        imageIndex = 2;
-      }
-      else if (hasScrambled)
-      {
-        imageIndex = 1;
-      }
-      else
-      {
-        imageIndex = 0;
-      }
-      return imageIndex;
-    }
   }
 }
\ No newline at end of file
Index: TvEngine3/TVLibrary/SetupTv/Sections/RadioChannelMapping.Designer.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/RadioChannelMapping.Designer.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/RadioChannelMapping.Designer.cs	(working copy)
@@ -30,66 +30,128 @@
     {
       this.components = new System.ComponentModel.Container();
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(RadioChannelMapping));
-      this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
+      this.imageList1 = new System.Windows.Forms.ImageList(this.components);
+      this.tabControl1 = new System.Windows.Forms.TabControl();
+      this.tabPage1 = new System.Windows.Forms.TabPage();
+      this.mpCheckBoxMapForEpgOnly = new MediaPortal.UserInterface.Controls.MPCheckBox();
+      this.pictureBox1 = new System.Windows.Forms.PictureBox();
       this.mpButtonUnmap = new MediaPortal.UserInterface.Controls.MPButton();
       this.mpButtonMap = new MediaPortal.UserInterface.Controls.MPButton();
       this.mpLabel3 = new MediaPortal.UserInterface.Controls.MPLabel();
       this.mpListViewMapped = new MediaPortal.UserInterface.Controls.MPListView();
-      this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
+      this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
       this.mpLabel2 = new MediaPortal.UserInterface.Controls.MPLabel();
       this.mpListViewChannels = new MediaPortal.UserInterface.Controls.MPListView();
+      this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
       this.mpLabel1 = new MediaPortal.UserInterface.Controls.MPLabel();
       this.mpComboBoxCard = new MediaPortal.UserInterface.Controls.MPComboBox();
-      this.pictureBox1 = new System.Windows.Forms.PictureBox();
-      this.tabControl1 = new System.Windows.Forms.TabControl();
-      this.tabPage1 = new System.Windows.Forms.TabPage();
       this.mpLabelChannelCount = new MediaPortal.UserInterface.Controls.MPLabel();
-      this.imageList1 = new System.Windows.Forms.ImageList(this.components);
-      ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
       this.tabControl1.SuspendLayout();
       this.tabPage1.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
       this.SuspendLayout();
       // 
-      // columnHeader2
+      // imageList1
       // 
-      this.columnHeader2.Text = "Name";
-      this.columnHeader2.Width = 180;
+      this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
+      this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
+      this.imageList1.Images.SetKeyName(0, "radio_fta_.png");
+      this.imageList1.Images.SetKeyName(1, "radio_scrambled.png");
+      this.imageList1.Images.SetKeyName(2, "icon.radio_scrambled_and_fta.png");
+      this.imageList1.Images.SetKeyName(3, "tv_fta_.png");
+      this.imageList1.Images.SetKeyName(4, "tv_scrambled.png");
+      this.imageList1.Images.SetKeyName(5, "icon.tv_scrambled_and_fta.png");
       // 
+      // tabControl1
+      // 
+      this.tabControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl1.Controls.Add(this.tabPage1);
+      this.tabControl1.Location = new System.Drawing.Point(3, 3);
+      this.tabControl1.Name = "tabControl1";
+      this.tabControl1.SelectedIndex = 0;
+      this.tabControl1.Size = new System.Drawing.Size(454, 392);
+      this.tabControl1.TabIndex = 0;
+      // 
+      // tabPage1
+      // 
+      this.tabPage1.Controls.Add(this.mpCheckBoxMapForEpgOnly);
+      this.tabPage1.Controls.Add(this.pictureBox1);
+      this.tabPage1.Controls.Add(this.mpButtonUnmap);
+      this.tabPage1.Controls.Add(this.mpButtonMap);
+      this.tabPage1.Controls.Add(this.mpLabel3);
+      this.tabPage1.Controls.Add(this.mpListViewMapped);
+      this.tabPage1.Controls.Add(this.mpLabel2);
+      this.tabPage1.Controls.Add(this.mpListViewChannels);
+      this.tabPage1.Controls.Add(this.mpLabel1);
+      this.tabPage1.Controls.Add(this.mpComboBoxCard);
+      this.tabPage1.Controls.Add(this.mpLabelChannelCount);
+      this.tabPage1.Location = new System.Drawing.Point(4, 22);
+      this.tabPage1.Name = "tabPage1";
+      this.tabPage1.Padding = new System.Windows.Forms.Padding(3);
+      this.tabPage1.Size = new System.Drawing.Size(446, 366);
+      this.tabPage1.TabIndex = 0;
+      this.tabPage1.Text = "Radio Mapping";
+      this.tabPage1.UseVisualStyleBackColor = true;
+      // 
+      // mpCheckBoxMapForEpgOnly
+      // 
+      this.mpCheckBoxMapForEpgOnly.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.mpCheckBoxMapForEpgOnly.AutoSize = true;
+      this.mpCheckBoxMapForEpgOnly.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
+      this.mpCheckBoxMapForEpgOnly.Location = new System.Drawing.Point(6, 343);
+      this.mpCheckBoxMapForEpgOnly.Name = "mpCheckBoxMapForEpgOnly";
+      this.mpCheckBoxMapForEpgOnly.Size = new System.Drawing.Size(355, 17);
+      this.mpCheckBoxMapForEpgOnly.TabIndex = 6;
+      this.mpCheckBoxMapForEpgOnly.Text = "Perform mapping for EPG grabbing only (you can also use doubleclick)";
+      this.mpCheckBoxMapForEpgOnly.UseVisualStyleBackColor = true;
+      // 
+      // pictureBox1
+      // 
+      this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
+      this.pictureBox1.Location = new System.Drawing.Point(3, 2);
+      this.pictureBox1.Name = "pictureBox1";
+      this.pictureBox1.Size = new System.Drawing.Size(33, 23);
+      this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
+      this.pictureBox1.TabIndex = 26;
+      this.pictureBox1.TabStop = false;
+      // 
       // mpButtonUnmap
       // 
-      this.mpButtonUnmap.Location = new System.Drawing.Point(215, 130);
+      this.mpButtonUnmap.Location = new System.Drawing.Point(211, 103);
       this.mpButtonUnmap.Name = "mpButtonUnmap";
       this.mpButtonUnmap.Size = new System.Drawing.Size(27, 23);
       this.mpButtonUnmap.TabIndex = 4;
       this.mpButtonUnmap.Text = "<<";
       this.mpButtonUnmap.UseVisualStyleBackColor = true;
-      this.mpButtonUnmap.Click += new System.EventHandler(this.mpButtonUnmap_Click_1);
+      this.mpButtonUnmap.Click += new System.EventHandler(this.mpButtonUnmap_Click);
       // 
       // mpButtonMap
       // 
-      this.mpButtonMap.Location = new System.Drawing.Point(215, 101);
+      this.mpButtonMap.Location = new System.Drawing.Point(211, 74);
       this.mpButtonMap.Name = "mpButtonMap";
       this.mpButtonMap.Size = new System.Drawing.Size(27, 23);
       this.mpButtonMap.TabIndex = 3;
       this.mpButtonMap.Text = ">>";
       this.mpButtonMap.UseVisualStyleBackColor = true;
-      this.mpButtonMap.Click += new System.EventHandler(this.mpButtonMap_Click_1);
+      this.mpButtonMap.Click += new System.EventHandler(this.mpButtonMap_Click);
       // 
       // mpLabel3
       // 
       this.mpLabel3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)));
       this.mpLabel3.AutoSize = true;
-      this.mpLabel3.Location = new System.Drawing.Point(245, 42);
+      this.mpLabel3.Location = new System.Drawing.Point(250, 32);
       this.mpLabel3.Name = "mpLabel3";
-      this.mpLabel3.Size = new System.Drawing.Size(154, 13);
-      this.mpLabel3.TabIndex = 13;
+      this.mpLabel3.Size = new System.Drawing.Size(131, 13);
+      this.mpLabel3.TabIndex = 0;
       this.mpLabel3.Text = "Radio stations mapped to card:";
       // 
       // mpListViewMapped
       // 
       this.mpListViewMapped.AllowDrop = true;
-      this.mpListViewMapped.AllowRowReorder = true;
+      this.mpListViewMapped.AllowRowReorder = false;
       this.mpListViewMapped.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
@@ -97,55 +159,61 @@
             this.columnHeader2});
       this.mpListViewMapped.IsChannelListView = false;
       this.mpListViewMapped.LargeImageList = this.imageList1;
-      this.mpListViewMapped.Location = new System.Drawing.Point(248, 61);
+      this.mpListViewMapped.Location = new System.Drawing.Point(246, 50);
       this.mpListViewMapped.Name = "mpListViewMapped";
-      this.mpListViewMapped.Size = new System.Drawing.Size(196, 292);
+      this.mpListViewMapped.Size = new System.Drawing.Size(193, 290);
       this.mpListViewMapped.SmallImageList = this.imageList1;
-      this.mpListViewMapped.TabIndex = 2;
+      this.mpListViewMapped.TabIndex = 5;
       this.mpListViewMapped.UseCompatibleStateImageBehavior = false;
       this.mpListViewMapped.View = System.Windows.Forms.View.Details;
       this.mpListViewMapped.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.mpListViewMapped_ColumnClick);
+      this.mpListViewMapped.DoubleClick += new System.EventHandler(this.mpListViewMapped_DoubleClick);
       // 
-      // columnHeader4
+      // columnHeader2
       // 
-      this.columnHeader4.Text = "Name";
-      this.columnHeader4.Width = 180;
+      this.columnHeader2.Text = "Name";
+      this.columnHeader2.Width = 180;
       // 
       // mpLabel2
       // 
       this.mpLabel2.AutoSize = true;
-      this.mpLabel2.Location = new System.Drawing.Point(3, 42);
+      this.mpLabel2.Location = new System.Drawing.Point(0, 32);
       this.mpLabel2.Name = "mpLabel2";
-      this.mpLabel2.Size = new System.Drawing.Size(118, 13);
-      this.mpLabel2.TabIndex = 11;
+      this.mpLabel2.Size = new System.Drawing.Size(99, 13);
+      this.mpLabel2.TabIndex = 0;
       this.mpLabel2.Text = "Available radio stations:";
       // 
       // mpListViewChannels
       // 
       this.mpListViewChannels.AllowDrop = true;
-      this.mpListViewChannels.AllowRowReorder = true;
+      this.mpListViewChannels.AllowRowReorder = false;
       this.mpListViewChannels.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)));
       this.mpListViewChannels.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
             this.columnHeader4});
       this.mpListViewChannels.IsChannelListView = false;
       this.mpListViewChannels.LargeImageList = this.imageList1;
-      this.mpListViewChannels.Location = new System.Drawing.Point(6, 61);
+      this.mpListViewChannels.Location = new System.Drawing.Point(3, 50);
       this.mpListViewChannels.Name = "mpListViewChannels";
-      this.mpListViewChannels.Size = new System.Drawing.Size(193, 292);
+      this.mpListViewChannels.Size = new System.Drawing.Size(193, 290);
       this.mpListViewChannels.SmallImageList = this.imageList1;
-      this.mpListViewChannels.TabIndex = 1;
+      this.mpListViewChannels.TabIndex = 2;
       this.mpListViewChannels.UseCompatibleStateImageBehavior = false;
       this.mpListViewChannels.View = System.Windows.Forms.View.Details;
       this.mpListViewChannels.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.mpListViewChannels_ColumnClick);
       // 
+      // columnHeader4
+      // 
+      this.columnHeader4.Text = "Name";
+      this.columnHeader4.Width = 180;
+      // 
       // mpLabel1
       // 
       this.mpLabel1.AutoSize = true;
-      this.mpLabel1.Location = new System.Drawing.Point(44, 7);
+      this.mpLabel1.Location = new System.Drawing.Point(42, 9);
       this.mpLabel1.Name = "mpLabel1";
       this.mpLabel1.Size = new System.Drawing.Size(32, 13);
-      this.mpLabel1.TabIndex = 9;
+      this.mpLabel1.TabIndex = 0;
       this.mpLabel1.Text = "Card:";
       // 
       // mpComboBoxCard
@@ -154,104 +222,52 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.mpComboBoxCard.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.mpComboBoxCard.FormattingEnabled = true;
-      this.mpComboBoxCard.Location = new System.Drawing.Point(79, 4);
+      this.mpComboBoxCard.Location = new System.Drawing.Point(80, 6);
       this.mpComboBoxCard.Name = "mpComboBoxCard";
-      this.mpComboBoxCard.Size = new System.Drawing.Size(365, 21);
-      this.mpComboBoxCard.TabIndex = 0;
-      this.mpComboBoxCard.SelectedIndexChanged += new System.EventHandler(this.mpComboBoxCard_SelectedIndexChanged_1);
+      this.mpComboBoxCard.Size = new System.Drawing.Size(360, 21);
+      this.mpComboBoxCard.TabIndex = 1;
+      this.mpComboBoxCard.SelectedIndexChanged += new System.EventHandler(this.mpComboBoxCard_SelectedIndexChanged);
       // 
-      // pictureBox1
-      // 
-      this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
-      this.pictureBox1.Location = new System.Drawing.Point(6, 4);
-      this.pictureBox1.Name = "pictureBox1";
-      this.pictureBox1.Size = new System.Drawing.Size(33, 23);
-      this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
-      this.pictureBox1.TabIndex = 16;
-      this.pictureBox1.TabStop = false;
-      // 
-      // tabControl1
-      // 
-      this.tabControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.tabControl1.Controls.Add(this.tabPage1);
-      this.tabControl1.Location = new System.Drawing.Point(3, 3);
-      this.tabControl1.Name = "tabControl1";
-      this.tabControl1.SelectedIndex = 0;
-      this.tabControl1.Size = new System.Drawing.Size(464, 385);
-      this.tabControl1.TabIndex = 17;
-      // 
-      // tabPage1
-      // 
-      this.tabPage1.Controls.Add(this.mpLabelChannelCount);
-      this.tabPage1.Controls.Add(this.pictureBox1);
-      this.tabPage1.Controls.Add(this.mpButtonUnmap);
-      this.tabPage1.Controls.Add(this.mpComboBoxCard);
-      this.tabPage1.Controls.Add(this.mpButtonMap);
-      this.tabPage1.Controls.Add(this.mpLabel1);
-      this.tabPage1.Controls.Add(this.mpLabel3);
-      this.tabPage1.Controls.Add(this.mpListViewChannels);
-      this.tabPage1.Controls.Add(this.mpListViewMapped);
-      this.tabPage1.Controls.Add(this.mpLabel2);
-      this.tabPage1.Location = new System.Drawing.Point(4, 22);
-      this.tabPage1.Name = "tabPage1";
-      this.tabPage1.Padding = new System.Windows.Forms.Padding(3);
-      this.tabPage1.Size = new System.Drawing.Size(456, 359);
-      this.tabPage1.TabIndex = 0;
-      this.tabPage1.Text = "Radio Mapping";
-      this.tabPage1.UseVisualStyleBackColor = true;
-      // 
       // mpLabelChannelCount
       // 
       this.mpLabelChannelCount.AutoSize = true;
       this.mpLabelChannelCount.Location = new System.Drawing.Point(13, 14);
       this.mpLabelChannelCount.Name = "mpLabelChannelCount";
       this.mpLabelChannelCount.Size = new System.Drawing.Size(0, 13);
-      this.mpLabelChannelCount.TabIndex = 2;
+      this.mpLabelChannelCount.TabIndex = 0;
       // 
-      // imageList1
-      // 
-      this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
-      this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
-      this.imageList1.Images.SetKeyName(0, "radio_fta_.png");
-      this.imageList1.Images.SetKeyName(1, "radio_scrambled.png");
-      this.imageList1.Images.SetKeyName(2, "icon.radio_scrambled_and_fta.png");
-      this.imageList1.Images.SetKeyName(3, "tv_fta_.png");
-      this.imageList1.Images.SetKeyName(4, "tv_scrambled.png");
-      this.imageList1.Images.SetKeyName(5, "icon.tv_scrambled_and_fta.png");
-      // 
       // RadioChannelMapping
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.tabControl1);
       this.Name = "RadioChannelMapping";
-      this.Size = new System.Drawing.Size(467, 388);
-      ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
+      this.Size = new System.Drawing.Size(457, 395);
       this.tabControl1.ResumeLayout(false);
       this.tabPage1.ResumeLayout(false);
       this.tabPage1.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
       this.ResumeLayout(false);
 
     }
 
     #endregion
 
-    private System.Windows.Forms.ColumnHeader columnHeader2;
+    private System.Windows.Forms.ImageList imageList1;
+    private System.Windows.Forms.TabControl tabControl1;
+    private System.Windows.Forms.TabPage tabPage1;
+    private MediaPortal.UserInterface.Controls.MPLabel mpLabelChannelCount;
+    private System.Windows.Forms.PictureBox pictureBox1;
     private MediaPortal.UserInterface.Controls.MPButton mpButtonUnmap;
     private MediaPortal.UserInterface.Controls.MPButton mpButtonMap;
     private MediaPortal.UserInterface.Controls.MPLabel mpLabel3;
     private MediaPortal.UserInterface.Controls.MPListView mpListViewMapped;
-    private System.Windows.Forms.ColumnHeader columnHeader4;
+    private System.Windows.Forms.ColumnHeader columnHeader2;
     private MediaPortal.UserInterface.Controls.MPLabel mpLabel2;
     private MediaPortal.UserInterface.Controls.MPListView mpListViewChannels;
+    private System.Windows.Forms.ColumnHeader columnHeader4;
     private MediaPortal.UserInterface.Controls.MPLabel mpLabel1;
     private MediaPortal.UserInterface.Controls.MPComboBox mpComboBoxCard;
-    private System.Windows.Forms.PictureBox pictureBox1;
-		private System.Windows.Forms.TabControl tabControl1;
-		private System.Windows.Forms.TabPage tabPage1;
-		private MediaPortal.UserInterface.Controls.MPLabel mpLabelChannelCount;
-    private System.Windows.Forms.ImageList imageList1;
+    private MediaPortal.UserInterface.Controls.MPCheckBox mpCheckBoxMapForEpgOnly;
   }
 }
\ No newline at end of file
Index: TvEngine3/TVLibrary/SetupTv/Sections/RadioChannels.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/RadioChannels.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/RadioChannels.cs	(working copy)
@@ -20,14 +20,12 @@
 
 using System;
 using System.Collections.Generic;
-using System.Text;
 using System.Windows.Forms;
 using SetupTv.Dialogs;
 using TvControl;
 using MediaPortal.Playlists;
 using Gentle.Framework;
 using TvDatabase;
-using TvLibrary.Log;
 using TvLibrary.Interfaces;
 using MediaPortal.UserInterface.Controls;
 using System.Threading;
@@ -95,7 +93,6 @@
       base.OnSectionDeActivated();
     }
 
-
     public override void OnSectionActivated()
     {
       base.OnSectionActivated();
@@ -167,6 +164,9 @@
       addToFavoritesToolStripMenuItem.DropDownItems.Add(itemNew);
     }
 
+    /// <summary>
+    /// Get all channels from the database
+    /// </summary>
     private void RefreshAllChannels()
     {
       Cursor.Current = Cursors.WaitCursor;
@@ -184,11 +184,15 @@
       _allChannels = ObjectFactory.GetCollection<Channel>(stmt.Execute());
       tabControl1.TabPages[0].Text = string.Format("Channels ({0})", _allChannels.Count);
 
-      _lvChannelHandler = new ChannelListViewHandler(mpListView1, _allChannels, _cards, txtFilterString,
-                                                     ChannelType.Radio);
+      _lvChannelHandler = new ChannelListViewHandler(mpListView1, _allChannels, _cards, txtFilterString, ChannelType.Radio);
       _lvChannelHandler.FilterListView("");
     }
 
+    /// <summary>
+    /// Text of the filter has changed
+    /// </summary>
+    /// <param name="sender"></param>
+    /// <param name="e"></param>
     private void txtFilterString_TextChanged(object sender, EventArgs e)
     {
       //Filter the listview so only items that contain the text of txtFilterString are shown
@@ -254,8 +258,7 @@
         return;
       }
 
-      NotifyForm dlg = new NotifyForm("Clearing all radio channels...",
-                                      "This can take some time\n\nPlease be patient...");
+      NotifyForm dlg = new NotifyForm("Clearing all radio channels...", "This can take some time\n\nPlease be patient...");
       dlg.Show(this);
       dlg.WaitForDisplay();
       IList<Channel> channels = Channel.ListAll();
@@ -950,7 +953,6 @@
 
       int targetIndex = -1;
 
-
       System.Drawing.Point pt = new System.Drawing.Point(e.X, e.Y);
 
       pt = PointToClient(pt);
